unit diag;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    procedure PaintBox1Paint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.PaintBox1Paint(Sender: TObject);
  procedure sector(clr:TColor;angle1,angle2:real;msg:string);
  Var x1, x2, y1, y2: integer;
      pw, ph: integer;
  begin
    pw:=PaintBox1.Width;
    ph:=PaintBox1.Height;
    PaintBox1.Canvas.Brush.Color:=clr;
    x1:=trunc(cos(angle1)*pw/2+pw/2);
    y1:=ph-trunc(sin(angle1)*ph/2+ph/2);
    x2:=trunc(cos(angle2)*pw/2+pw/2);
    y2:=ph-trunc(sin(angle2)*ph/2+ph/2);
    PaintBox1.Canvas.Pie(0,0,pw,ph,x1,y1,x2,y2);
    PaintBox1.Font.Name:='Arial';
    PaintBox1.Font.Size:=8;
    PaintBox1.Font.Color:=clBlack;
    PaintBox1.Font.Style:=[fsBold];
    PaintBox1.Canvas.TextOut(trunc((x1+x2)/2-20),
    trunc((y1+y2)/2),msg);
  end;

begin
 sector(clRed,0,pi/3,'16,5%');
 sector(clWhite,pi/3,5*pi/6,'25%');
 sector(clBlue,5*pi/6,7*pi/5,'28,4%');
 sector(clYellow,7*pi/5,2*pi,'30%');
end;

end.
